#ifndef POLSKAOUTPUTFORMAT_H
#define POLSKAOUTPUTFORMAT_H

/***************************************************************************
 *   Copyright (C) 2007-2008 by Sergio Pistone                             *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <outputformat.h>
#include <qstring.h>

namespace SubtitleComposer
{
	class PolskaOutputFormat : public OutputFormat
	{
		friend class FormatsManager;

		public:
			~PolskaOutputFormat() {}

			virtual QString dumpSubtitles( const Subtitle& subtitle ) const
			{
				QString ret;

				const int size = subtitle.linesCount();
				for ( int idx = 0; idx < size; ++idx )
				{
					const SubtitleLine* line = subtitle.line( idx );

					Time showTime = line->showTime();
					ret += m_builder.sprintf(
						"%02d:%02d:%02d:",
						showTime.hours(),
						showTime.minutes(),
						showTime.seconds()
					);

					ret += line->text().replace( "\n", "|" );
					ret += "\n";
				}

				return ret;
			}

		protected:

			PolskaOutputFormat():
				OutputFormat( "Polska", "txt" )
			{
			}

			mutable QString m_builder;
	};
}

#endif
